import React from "react";
interface BootstrapTableProps {
    keyField: string;
    data: any[];
    columns: any[];
    bootstrap4: boolean;
    remote: boolean | {
        pagination: boolean;
    };
    noDataIndication: any;
    striped: boolean;
    bordered: boolean;
    hover: boolean;
    tabIndexCell?: boolean;
    id?: string;
    classes?: string;
    headerClasses?: string;
    bodyClasses?: string;
    wrapperClasses?: string;
    headerWrapperClasses?: string;
    condensed: boolean;
    caption?: React.ReactNode | string;
    pagination?: any;
    filter?: any;
    currFilters?: any;
    cellEdit: any;
    selectRow: any;
    expandRow: any;
    rowStyle?: React.CSSProperties | ((row: any, rowIndex: number) => React.CSSProperties);
    rowEvents?: Record<string, any>;
    rowClasses?: string | ((row: any, rowIndex: number) => string);
    filtersClasses?: string;
    filterPosition: string;
    footerClasses?: string;
    sortField?: string;
    sortOrder?: string;
    defaultSorted?: Array<{
        dataField: string;
        order: string;
    }>;
    sort?: {
        dataField: string;
        order: string;
        sortFunc?: (a: any, b: any, order: string, dataField: string) => number;
        sortCaret?: (order: string, column: any) => JSX.Element;
    };
    defaultSortDirection?: string;
    loading?: boolean;
    overlay?: (loading: boolean) => any;
    onTableChange?: (type: string, newState: Record<string, any>) => void;
    onSort?: () => void;
    onFilter?: (filterData: Record<string, any>) => void;
    onExternalFilter?: () => () => void;
    onDataSizeChange?: (options: {
        dataSize: number;
    }) => void;
    search?: {
        searchText: string;
        searchContext: (cell: any, filterValue: string, row: any) => boolean;
    };
    setDependencyModules?: (deps: Record<string, any>) => void;
}
declare const BootstrapTable_base: {
    new (props: any): {
        validateProps(): void;
        isEmpty(): boolean;
        visibleRows(): any;
        visibleColumnSize(includeSelectColumn?: boolean): any;
        context: unknown;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<any>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        render(): React.ReactNode;
        readonly props: Readonly<any>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<any>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<any>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): void;
    };
    new (props: any, context: any): {
        validateProps(): void;
        isEmpty(): boolean;
        visibleRows(): any;
        visibleColumnSize(includeSelectColumn?: boolean): any;
        context: unknown;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<any>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        render(): React.ReactNode;
        readonly props: Readonly<any>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<any>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<any>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): void;
    };
    contextType?: React.Context<any> | undefined;
};
declare class BootstrapTable extends BootstrapTable_base {
    constructor(props: BootstrapTableProps);
    componentDidUpdate(nextProps: BootstrapTableProps): void;
    getData: () => any;
    render(): React.JSX.Element;
    renderTable(): React.JSX.Element;
}
export default BootstrapTable;
