"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
var react_1 = __importDefault(require("react"));
var ColumnManagementProvider = function ColumnManagementProvider(_ref) {
  var columns = _ref.columns,
    toggles = _ref.toggles,
    children = _ref.children;
  var toggleColumn;
  if (toggles) {
    toggleColumn = columns.filter(function (column) {
      return toggles[column.dataField];
    });
  } else {
    toggleColumn = columns.filter(function (column) {
      return !column.hidden;
    });
  }
  var columnManagementValue = {
    columns: toggleColumn
  };
  return react_1["default"].createElement(ColumnManagementContext.Provider, {
    value: columnManagementValue
  }, children);
};
// ColumnManagementProvider.propTypes = {
//   columns: PropTypes.array.isRequired,
//   toggles: PropTypes.object,
//   children: PropTypes.node.isRequired,
// };
var ColumnManagementContext = react_1["default"].createContext(undefined);
exports["default"] = function () {
  return {
    Provider: ColumnManagementProvider,
    Consumer: ColumnManagementContext.Consumer
  };
};