/// <reference types="node" />
import EventEmitter from "events";
import React from "react";
declare const withContext: (Base: any) => {
    new (props: any): {
        componentDidUpdate(nextProps: any): void;
        renderBase(): (rootProps: {
            getData: (filterProps: any, searchProps: any, sortProps: any, paginationProps: any) => any;
        }, filterProps: any, searchProps: any, sortProps: any, paginationProps: any, columnToggleProps: any) => React.JSX.Element;
        renderWithColumnManagementCtx(base: any, baseProps: any): (rootProps: any, filterProps: any, searchProps: any, sortProps: any, paginationProps: any) => React.JSX.Element;
        renderWithSelectionCtx(base: any, baseProps: any): (rootProps: {
            getData: (filterProps: any, searchProps: any, sortProps: any, paginationProps: any) => any;
        }, filterProps: any, searchProps: any, sortProps: any, paginationProps: any) => React.JSX.Element;
        renderWithRowExpandCtx(base: any, baseProps: any): (rootProps: {
            getData: (filterProps: any, searchProps: any, sortProps: any, paginationProps: any) => any;
        }, filterProps: any, searchProps: any, sortProps: any, paginationProps: any) => React.JSX.Element;
        renderWithPaginationCtx(base: any): (rootProps: {
            getData: (filterProps: any, searchProps: any, sortProps: any, paginationProps?: any) => any;
        }, filterProps: any, searchProps: any, sortProps: any) => React.JSX.Element;
        renderWithSortCtx(base: any, baseProps: any): (rootProps: {
            getData: (filterProps: any, searchProps: any, sortProps?: any, paginationProps?: any) => any;
        }, filterProps: any, searchProps: any) => React.JSX.Element;
        renderWithSearchCtx(base: any, baseProps: any): (rootProps: {
            getData: (filterProps: any, searchProps?: any, sortProps?: any, paginationProps?: any) => any;
        }, filterProps: any) => React.JSX.Element;
        renderWithFilterCtx(base: any, baseProps: any): (rootProps: any) => React.JSX.Element;
        renderWithCellEditCtx(base: any, baseProps: any): (rootProps: {
            getData: (filterProps?: any, searchProps?: any, sortProps?: any, paginationProps?: any) => any;
        }) => React.JSX.Element;
        render(): React.JSX.Element;
        remoteEmitter: EventEmitter;
        DataContext: any;
        SortContext: any;
        ColumnManagementContext: any;
        SelectionContext: any;
        rowExpandContext: any;
        CellEditContext: any;
        FilterContext: any;
        PaginationContext: any;
        SearchContext: any;
        table: any;
        getNewestState: (state?: any) => any;
        isRemoteSearch: () => any;
        isRemotePagination: (e?: any) => any;
        isRemoteFiltering: () => any;
        isRemoteSort: () => any;
        isRemoteCellEdit: () => any;
        handleRemotePageChange: (page: number, sizePerPage: number) => void;
        handleRemoteFilterChange: (filters: any) => void;
        handleRemoteSortChange: (sortField: string, sortOrder: string) => void;
        handleRemoteCellChange: (rowId: any, dataField: string, newValue: any) => void;
        handleRemoteSearchChange: (searchText: string) => void;
        context: unknown;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<any>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<any>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<any>, prevState: Readonly<{}>): any;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{}>, nextContext: any): void;
    };
    contextType?: React.Context<any> | undefined;
};
export default withContext;
