"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
var events_1 = __importDefault(require("events"));
var react_1 = __importDefault(require("react"));
var remote_resolver_1 = __importDefault(require("../props-resolver/remote-resolver"));
var operators_1 = __importDefault(require("../store/operators"));
var utils_1 = __importDefault(require("../utils"));
var bootstrap_1 = require("./bootstrap");
var column_context_1 = __importDefault(require("./column-context"));
var data_context_1 = __importDefault(require("./data-context"));
var row_expand_context_1 = __importDefault(require("./row-expand-context"));
var selection_context_1 = __importDefault(require("./selection-context"));
var sort_context_1 = __importDefault(require("./sort-context"));
var withContext = function withContext(Base) {
  return /*#__PURE__*/function (_ref) {
    _inherits(BootstrapTableContainer, _ref);
    var _super = _createSuper(BootstrapTableContainer);
    function BootstrapTableContainer(props) {
      var _this;
      _classCallCheck(this, BootstrapTableContainer);
      _this = _super.call(this, props);
      _this.DataContext = (0, data_context_1["default"])();
      if (props.registerExposedAPI) {
        var exposedAPIEmitter = new events_1["default"]();
        exposedAPIEmitter.on("get.table.data", function (payload) {
          return payload.result = _this.table.getData();
        });
        exposedAPIEmitter.on("get.selected.rows", function (payload) {
          return payload.result = _this.SelectionContext.getSelected();
        });
        exposedAPIEmitter.on("get.filtered.rows", function (payload) {
          if (_this.SearchContext) {
            payload.result = _this.SearchContext.getSearched();
          } else if (_this.FilterContext) {
            payload.result = _this.FilterContext.getFiltered();
          } else {
            payload.result = _this.table.getData();
          }
        });
        props.registerExposedAPI(exposedAPIEmitter);
      }
      if (props.columns.filter(function (col) {
        return col.sort;
      }).length > 0) {
        _this.SortContext = (0, sort_context_1["default"])(operators_1["default"], _this.isRemoteSort, _this.handleRemoteSortChange);
      }
      if (props.columnToggle || props.columns.filter(function (col) {
        return col.hidden;
      }).length > 0) {
        _this.ColumnManagementContext = (0, column_context_1["default"])();
      }
      if (props.selectRow) {
        _this.SelectionContext = selection_context_1["default"];
      }
      if (props.expandRow) {
        _this.rowExpandContext = row_expand_context_1["default"];
      }
      if (props.cellEdit && props.cellEdit.createContext) {
        _this.CellEditContext = props.cellEdit.createContext(utils_1["default"], operators_1["default"], _this.isRemoteCellEdit, _this.handleRemoteCellChange);
      }
      if (props.filter) {
        _this.FilterContext = props.filter.createContext(utils_1["default"], _this.isRemoteFiltering, _this.handleRemoteFilterChange);
      }
      if (props.pagination) {
        _this.PaginationContext = props.pagination.createContext();
      }
      if (props.search && props.search.searchContext) {
        _this.SearchContext = props.search.searchContext(utils_1["default"], _this.isRemoteSearch, _this.handleRemoteSearchChange);
      }
      if (props.setDependencyModules) {
        props.setDependencyModules(utils_1["default"]);
      }
      if (props.setPaginationRemoteEmitter) {
        props.setPaginationRemoteEmitter(_this.remoteEmitter);
      }
      return _this;
    }
    _createClass(BootstrapTableContainer, [{
      key: "componentDidUpdate",
      value: function componentDidUpdate(nextProps) {
        if (nextProps.columns.filter(function (col) {
          return col.sort;
        }).length <= 0) {
          this.SortContext = null;
        } else if (!this.SortContext) {
          this.SortContext = (0, sort_context_1["default"])(operators_1["default"], this.isRemoteSort, this.handleRemoteSortChange);
        }
        if (!nextProps.pagination && this.props.pagination) {
          this.PaginationContext = null;
        }
        if (nextProps.pagination && !this.props.pagination) {
          this.PaginationContext = nextProps.pagination.createContext(this.isRemotePagination, this.handleRemotePageChange);
        }
        if (!nextProps.cellEdit && this.props.cellEdit) {
          this.CellEditContext = null;
        }
        if (nextProps.cellEdit && !this.props.cellEdit) {
          this.CellEditContext = nextProps.cellEdit.createContext(utils_1["default"], operators_1["default"], this.isRemoteCellEdit, this.handleRemoteCellChange);
        }
      }
    }, {
      key: "renderBase",
      value: function renderBase() {
        var _this2 = this;
        return function (rootProps, filterProps, searchProps, sortProps, paginationProps, columnToggleProps) {
          return react_1["default"].createElement(Base, Object.assign({
            ref: function ref(n) {
              return _this2.table = n;
            }
          }, _this2.props, sortProps, filterProps, searchProps, paginationProps, columnToggleProps, {
            data: rootProps.getData(filterProps, searchProps, sortProps, paginationProps)
          }));
        };
      }
    }, {
      key: "renderWithColumnManagementCtx",
      value: function renderWithColumnManagementCtx(base, baseProps) {
        var _this3 = this;
        return function (rootProps, filterProps, searchProps, sortProps, paginationProps) {
          return react_1["default"].createElement(_this3.ColumnManagementContext.Provider, Object.assign({}, baseProps, {
            toggles: _this3.props.columnToggle ? _this3.props.columnToggle.toggles : null
          }), react_1["default"].createElement(_this3.ColumnManagementContext.Consumer, null, function (columnToggleProps) {
            return base(rootProps, filterProps, searchProps, sortProps, paginationProps, columnToggleProps);
          }));
        };
      }
    }, {
      key: "renderWithSelectionCtx",
      value: function renderWithSelectionCtx(base, baseProps) {
        var _this4 = this;
        return function (rootProps, filterProps, searchProps, sortProps, paginationProps) {
          return react_1["default"].createElement(_this4.SelectionContext.Provider, Object.assign({}, baseProps, {
            ref: function ref(n) {
              return _this4.SelectionContext = n;
            },
            selectRow: _this4.props.selectRow,
            data: rootProps.getData(filterProps, searchProps, sortProps, paginationProps)
          }), base(rootProps, filterProps, searchProps, sortProps, paginationProps));
        };
      }
    }, {
      key: "renderWithRowExpandCtx",
      value: function renderWithRowExpandCtx(base, baseProps) {
        var _this5 = this;
        return function (rootProps, filterProps, searchProps, sortProps, paginationProps) {
          return react_1["default"].createElement(_this5.rowExpandContext.Provider, Object.assign({}, baseProps, {
            ref: function ref(n) {
              return _this5.rowExpandContext = n;
            },
            expandRow: _this5.props.expandRow,
            data: rootProps.getData(filterProps, searchProps, sortProps, paginationProps)
          }), base(rootProps, filterProps, searchProps, sortProps, paginationProps));
        };
      }
    }, {
      key: "renderWithPaginationCtx",
      value: function renderWithPaginationCtx(base) {
        var _this6 = this;
        return function (rootProps, filterProps, searchProps, sortProps) {
          return react_1["default"].createElement(_this6.PaginationContext.Provider, {
            ref: function ref(n) {
              return _this6.PaginationContext = n;
            },
            pagination: _this6.props.pagination,
            data: rootProps.getData(filterProps, searchProps, sortProps),
            bootstrap4: _this6.props.bootstrap4,
            isRemotePagination: _this6.isRemotePagination,
            remoteEmitter: _this6.remoteEmitter,
            onDataSizeChange: _this6.props.onDataSizeChange,
            tableId: _this6.props.id
          }, react_1["default"].createElement(_this6.PaginationContext.Consumer, null, function (paginationProps) {
            return base(rootProps, filterProps, searchProps, sortProps, paginationProps);
          }));
        };
      }
    }, {
      key: "renderWithSortCtx",
      value: function renderWithSortCtx(base, baseProps) {
        var _this7 = this;
        return function (rootProps, filterProps, searchProps) {
          return react_1["default"].createElement(_this7.SortContext.Provider, Object.assign({}, baseProps, {
            ref: function ref(n) {
              return _this7.SortContext = n;
            },
            defaultSorted: _this7.props.defaultSorted,
            defaultSortDirection: _this7.props.defaultSortDirection,
            sort: _this7.props.sort,
            data: rootProps.getData(filterProps, searchProps)
          }), react_1["default"].createElement(_this7.SortContext.Consumer, null, function (sortProps) {
            return base(rootProps, filterProps, searchProps, sortProps);
          }));
        };
      }
    }, {
      key: "renderWithSearchCtx",
      value: function renderWithSearchCtx(base, baseProps) {
        var _this8 = this;
        return function (rootProps, filterProps) {
          return react_1["default"].createElement(_this8.SearchContext.Provider, Object.assign({}, baseProps, {
            ref: function ref(n) {
              return _this8.SearchContext = n;
            },
            data: rootProps.getData(filterProps),
            searchText: _this8.props.search.searchText,
            dataChangeListener: _this8.props.dataChangeListener
          }), react_1["default"].createElement(_this8.SearchContext.Consumer, null, function (searchProps) {
            return base(rootProps, filterProps, searchProps);
          }));
        };
      }
    }, {
      key: "renderWithFilterCtx",
      value: function renderWithFilterCtx(base, baseProps) {
        var _this9 = this;
        return function (rootProps) {
          return react_1["default"].createElement(_this9.FilterContext.Provider, Object.assign({}, baseProps, {
            ref: function ref(n) {
              return _this9.FilterContext = n;
            },
            data: rootProps.getData(),
            filter: _this9.props.filter.options || {},
            dataChangeListener: _this9.props.dataChangeListener
          }), react_1["default"].createElement(_this9.FilterContext.Consumer, null, function (filterProps) {
            return base(rootProps, filterProps);
          }));
        };
      }
    }, {
      key: "renderWithCellEditCtx",
      value: function renderWithCellEditCtx(base, baseProps) {
        var _this10 = this;
        return function (rootProps) {
          return react_1["default"].createElement(_this10.CellEditContext.Provider, Object.assign({}, baseProps, {
            ref: function ref(n) {
              return _this10.CellEditContext = n;
            },
            selectRow: _this10.props.selectRow,
            cellEdit: _this10.props.cellEdit,
            data: rootProps.getData()
          }), base(rootProps));
        };
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props = this.props,
          keyField = _this$props.keyField,
          columns = _this$props.columns,
          bootstrap4 = _this$props.bootstrap4;
        var baseProps = {
          keyField: keyField,
          columns: columns
        };
        var base = this.renderBase();
        if (this.ColumnManagementContext) {
          base = this.renderWithColumnManagementCtx(base, baseProps);
        }
        if (this.SelectionContext) {
          base = this.renderWithSelectionCtx(base, baseProps);
        }
        if (this.rowExpandContext) {
          base = this.renderWithRowExpandCtx(base, baseProps);
        }
        if (this.PaginationContext) {
          base = this.renderWithPaginationCtx(base);
        }
        if (this.SortContext) {
          base = this.renderWithSortCtx(base, baseProps);
        }
        if (this.SearchContext) {
          base = this.renderWithSearchCtx(base, baseProps);
        }
        if (this.FilterContext) {
          base = this.renderWithFilterCtx(base, baseProps);
        }
        if (this.CellEditContext) {
          base = this.renderWithCellEditCtx(base, baseProps);
        }
        return react_1["default"].createElement(bootstrap_1.BootstrapContext.Provider, {
          value: {
            bootstrap4: bootstrap4
          }
        }, react_1["default"].createElement(this.DataContext.Provider, Object.assign({}, baseProps, {
          data: this.props.data
        }), react_1["default"].createElement(this.DataContext.Consumer, null, base)));
      }
    }]);
    return BootstrapTableContainer;
  }((0, remote_resolver_1["default"])(Base));
};
exports["default"] = withContext;