import PropTypes from "prop-types";
import React, { Component, ReactNode } from "react";
export interface SelectionContextProps {
    selected?: any[];
    onRowSelect?: (rowKey: any, checked: boolean, rowIndex: number, e: any) => void;
    onAllRowsSelect?: (e: any, isUnSelect: boolean) => void;
    allRowsSelected?: boolean;
    allRowsNotSelected?: boolean;
    checkedStatus?: string;
    mode?: string;
    hideSelectColumn?: boolean;
    clickToSelect?: boolean;
    clickToSelectAndEditCell?: boolean;
    onSelect?: (row: any, checked: boolean, rowIndex: number, e: any) => boolean | undefined;
    onSelectAll?: (checked: boolean, selectedRows: any[], e: any) => void | any[];
    nonSelectable?: any[];
    hideSelectAll?: boolean;
}
interface SelectionProviderProps {
    children: ReactNode;
    data: any[];
    keyField: string;
    selectRow: {
        selected?: any[];
        mode?: string;
        hideSelectColumn?: boolean;
        clickToSelect?: boolean;
        clickToSelectAndEditCell?: boolean;
        onSelect?: (row: any, checked: boolean, rowIndex: number, e: any) => boolean;
        onSelectAll?: (checked: boolean, selectedRows: any[], e: any) => void | any[];
        nonSelectable?: any[];
    };
}
declare class SelectionProvider extends Component<SelectionProviderProps> {
    static propTypes: {
        children: PropTypes.Validator<NonNullable<PropTypes.ReactNodeLike>>;
        data: PropTypes.Validator<any[]>;
        keyField: PropTypes.Validator<string>;
        selectRow: PropTypes.Requireable<PropTypes.InferProps<{
            selected: PropTypes.Requireable<any[]>;
            mode: PropTypes.Requireable<string>;
            hideSelectColumn: PropTypes.Requireable<boolean>;
            clickToSelect: PropTypes.Requireable<boolean>;
            clickToSelectAndEditCell: PropTypes.Requireable<boolean>;
            onSelect: PropTypes.Requireable<(...args: any[]) => any>;
            onSelectAll: PropTypes.Requireable<(...args: any[]) => any>;
            nonSelectable: PropTypes.Requireable<any[]>;
        }>>;
    };
    selected: any[];
    constructor(props: SelectionProviderProps);
    getSelected(): any[];
    componentDidUpdate(nextProps: SelectionProviderProps): void;
    handleRowSelect: (rowKey: any, checked: boolean, rowIndex: number, e: any) => void;
    handleAllRowsSelect: (e: any, isUnSelect: boolean) => void;
    render(): React.JSX.Element;
}
declare const _default: {
    Provider: typeof SelectionProvider;
    Consumer: React.Consumer<SelectionContextProps | undefined>;
};
export default _default;
