import PropTypes from "prop-types";
import React, { ReactNode } from "react";
interface SortContextValue {
    data: any[];
    sortOrder: string;
    onSort: (column: any) => void;
    sortField: string | null;
}
interface SortProviderProps {
    data: any[];
    columns: any[];
    children: ReactNode;
    defaultSorted?: Array<{
        dataField: string;
        order: string;
    }>;
    sort?: {
        dataField: string;
        order: string;
        sortFunc: (a: any, b: any, order: string, dataField: string) => number;
    };
    defaultSortDirection: string;
}
type DataOperator = {
    nextOrder: (column: any, state: {
        sortOrder: string;
        sortColumn: any;
    }, defaultSortDirection: string) => string;
    sort: (data: any[], order: string, sortColumn: any) => any[];
};
type HandleSortChange = (dataField: string, sortOrder: string) => void;
declare const _default: (dataOperator: DataOperator, isRemoteSort: () => boolean, handleSortChange: HandleSortChange) => {
    Provider: {
        new (props: SortProviderProps): {
            componentDidMount(): void;
            componentDidUpdate(prevProps: SortProviderProps): void;
            initSort(sortField: string, sortOrder: string): any;
            handleSort: (column: any) => void;
            render(): React.JSX.Element;
            context: unknown;
            setState<K extends "sortOrder" | "sortColumn">(state: {
                sortOrder: any;
                sortColumn: any;
            } | ((prevState: Readonly<{
                sortOrder: any;
                sortColumn: any;
            }>, props: Readonly<SortProviderProps>) => {
                sortOrder: any;
                sortColumn: any;
            } | Pick<{
                sortOrder: any;
                sortColumn: any;
            }, K> | null) | Pick<{
                sortOrder: any;
                sortColumn: any;
            }, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<SortProviderProps>;
            state: Readonly<{
                sortOrder: any;
                sortColumn: any;
            }>;
            refs: {
                [key: string]: React.ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<SortProviderProps>, nextState: Readonly<{
                sortOrder: any;
                sortColumn: any;
            }>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<SortProviderProps>, prevState: Readonly<{
                sortOrder: any;
                sortColumn: any;
            }>): any;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<SortProviderProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<SortProviderProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<SortProviderProps>, nextState: Readonly<{
                sortOrder: any;
                sortColumn: any;
            }>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<SortProviderProps>, nextState: Readonly<{
                sortOrder: any;
                sortColumn: any;
            }>, nextContext: any): void;
        };
        propTypes: {
            data: PropTypes.Validator<any[]>;
            columns: PropTypes.Validator<any[]>;
            children: PropTypes.Validator<NonNullable<PropTypes.ReactNodeLike>>;
            defaultSorted: PropTypes.Requireable<(PropTypes.InferProps<{
                dataField: PropTypes.Validator<string>;
                order: PropTypes.Validator<string>;
            }> | null | undefined)[]>;
            sort: PropTypes.Requireable<PropTypes.InferProps<{
                dataField: PropTypes.Requireable<string>;
                order: PropTypes.Requireable<string>;
                sortFunc: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
            defaultSortDirection: PropTypes.Requireable<string>;
        };
        contextType?: React.Context<any> | undefined;
    };
    Consumer: React.Consumer<SortContextValue | undefined>;
};
export default _default;
