"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
var react_1 = __importDefault(require("react"));
var utils_1 = __importDefault(require("./utils"));
var FiltersCell = function FiltersCell(props) {
  var index = props.index,
    column = props.column,
    onExternalFilter = props.onExternalFilter,
    currFilters = props.currFilters,
    onFilter = props.onFilter;
  var filterRenderer = column.filterRenderer,
    filter = column.filter;
  var filterElm;
  var cellAttrs = {};
  var cellStyle = {};
  cellAttrs.style = cellStyle;
  if (column.headerAlign) {
    cellStyle.textAlign = utils_1["default"].isFunction(column.headerAlign) ? column.headerAlign(column, index) : column.headerAlign;
  }
  if (column.filterRenderer) {
    var onCustomFilter = onExternalFilter(column, (filter === null || filter === void 0 ? void 0 : filter.props.type) || "");
    filterElm = filterRenderer(onCustomFilter, column);
  } else if (filter) {
    filterElm = react_1["default"].createElement(filter.Filter, Object.assign({}, filter.props, {
      filterState: currFilters[column.dataField],
      onFilter: onFilter,
      column: column
    }));
  }
  return react_1["default"].createElement("th", cellAttrs, filterElm);
};
// FiltersCell.propTypes = {
//   index: PropTypes.number.isRequired,
//   column: PropTypes.shape({
//     filterRenderer: PropTypes.func,
//     filter: PropTypes.shape({
//       Filter: PropTypes.any,
//       props: PropTypes.object,
//     }),
//     headerAlign: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
//     dataField: PropTypes.string.isRequired,
//   }).isRequired,
//   currFilters: PropTypes.object.isRequired,
//   onFilter: PropTypes.func,
//   onExternalFilter: PropTypes.func,
// };
// FiltersCell.defaultProps = {
//   onFilter: () => {},
//   onExternalFilter: () => {},
// };
exports["default"] = FiltersCell;