"use strict";

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
var react_1 = __importDefault(require("react"));
var const_1 = __importDefault(require("../const"));
var RowTemplate = function RowTemplate(props) {
  var renderContent = props.renderContent,
    selectRow = props.selectRow,
    expandRow = props.expandRow,
    cellEl = props.cellEl,
    rest = __rest(props, ["renderContent", "selectRow", "expandRow", "cellEl"]);
  var isRenderFunctionColumnInLeft = function isRenderFunctionColumnInLeft() {
    var position = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : const_1["default"].INDICATOR_POSITION_LEFT;
    return position === const_1["default"].INDICATOR_POSITION_LEFT;
  };
  var childrens = renderContent() || [];
  if (selectRow && selectRow.hideSelectColumn !== true) {
    if (isRenderFunctionColumnInLeft(selectRow.selectColumnPosition)) {
      childrens.unshift(react_1["default"].createElement(cellEl, {
        key: "selection"
      }));
    } else {
      childrens.push(react_1["default"].createElement(cellEl, {
        key: "selection"
      }));
    }
  }
  if (expandRow && expandRow.showExpandColumn) {
    if (isRenderFunctionColumnInLeft(expandRow.expandColumnPosition)) {
      childrens.unshift(react_1["default"].createElement(cellEl, {
        key: "expansion"
      }));
    } else {
      childrens.push(react_1["default"].createElement(cellEl, {
        key: "expansion"
      }));
    }
  }
  return react_1["default"].createElement("tr", Object.assign({}, rest), childrens);
};
// RowTemplate.propTypes = {
//   renderContent: PropTypes.func.isRequired,
//   cellEl: PropTypes.string.isRequired,
//   selectRow: PropTypes.object,
//   expandRow: PropTypes.object
// };
exports["default"] = RowTemplate;